GRML-DEBOOTSTRAP(8)

NAME
grml-debootstrap - wrapper around mmdebstrap for installing plain Debian

SYNOPSIS

grml-debootstrap [ options ]

[IMAGE][1] [Screenshot]

INTRODUCTION

grml-debootstrap is a wrapper suite around mmdebstrap (and debootstrap) for installing a plain Debian system very fast and easy.

All you have to do is adjust a few variables in the configuration file /etc/debootstrap/config or specify some command line options and invoke grml-debootstrap. If invoked without any configuration modifications or command line options a dialog based front end will be available to control some basic configuration options.

A plain and base Debian system will be installed on the given device, directory or virtual image file then. Customization of this process is possible as well.

    Caution

    The Grml team does not take responsibility for loss of any data!

OPTIONS AND ENVIRONMENT VARIABLES

--arch architecture
    Set target architecture you want to install. Defaults to the architecture you are currently running. Example: "--arch amd64"

--backportrepos
    Enable Debian’s Backports repository via the /etc/apt/sources.list.d/backports.sources configuration file. This provides the option to install Debian packages from Debian’s backports repository.

--bootappend appendline-for-the-kernel
    Specify appendline for the kernel. E.g. "pci=nomsi"

-c, --config file
    Use specified configuration file, defaults to /etc/debootstrap/config.

--chroot-scripts directory
    Execute chroot scripts from specified directory. This allows customisation of the chroot setup, the executable script(s) present in the given directory are executed at the end of the chroot procedure. Default directory: /etc/debootstrap/chroot-scripts/

--contrib
    Enable the contrib repository in COMPONENTS. By default only the main repository is enabled.

-d, --confdir path
    Place of configuration files for debootstrap, defaults to /etc/debootstrap.

--debconf file
    Use specified file for preseeding Debian packages instead of using the default <confdir>/debconf-selections.

--debopt params
    Extra parameters passed to the debootstrap command.

--debug
    Execute in very verbose way. Useful for debugging possible problems with grml-debootstrap or identify what’s actually executed.

--defaultinterfaces
    Install a default /etc/network/interfaces file (enabling DHCP for all local Ethernet, WLAN and WWAN interfaces using predictable network interface names and using eth0 as traditional interface name for backward compatibility) instead of taking over config from host system. This option is automatically enabled when using --vm or --vmfile.

--efi device
    Partition where EFI boot manager should be installed to. If the specified device doesn’t use a FAT filesystem yet grml-debootstrap automatically creates the filesystem. If a FAT filesystem is already present the filesystem creation is skipped. Please ensure that it’s a valid FAT32 filesystem and the partition has the boot and esp flags enabled. This option requires EFI support on the running system and the option is NOT supported for Virtual Machine deployments.

--filesystem filesystem
    Filesystem that should be created when installing to a partition. If unset defaults to ext4. Valid values are all filesystems that can be created through mkfs.filesystem.

--force
    Skip user acknowledgement and do not prompt for user input.

--grmlrepos
    Enable Grml.org’s Debian repository (http://deb.grml.org/) via the /etc/apt/sources.list.d/grml.sources configuration file. This provides the option to install Debian packages from Grml’s repository.

--grub device
    Device where grub should be installed to. Note that only the MBR (master boot record) can be used (/dev/sda, /dev/sdb,...). Partitions (like /dev/sda1, /dev/sdb2,...) are NOT supported because grub2 doesn’t support installation into the PBR (partition boot record) anymore. Usage example: --grub /dev/sda. Note: just do not set this option to avoid installation of grub.

--help, -h
    Show summary of options and exit.

--hostname hostname
    Use specified hostname instead of the default (being $HOSTNAME or if unset grml).

--imagesize size
    Use specified size for size of Virtual Machine or Raspberry Pi disk file. If not specified it defaults to 2G (being 2GiB) for virtual machines, and 3G (being 3GiB) for Raspberry Pi images. Syntax as supported by qemu-img (see manpage qemu-img(1) for details. Usage example: --imagesize 3G

--keep_src_list
    Do not override user provided /etc/apt/sources.list.d/debian.sources or delete /etc/apt/sources.list.

-m, --mirror URL
    Specify mirror which should be used for apt-get/aptitude. Corresponding with configuration variable MIRROR.

--nodebootstrap
    Skip debootstrap, only do configuration to the target.

--nointerfaces
    Do not copy /etc/network/interfaces from host system to the target.

--nokernel
    Skip installation of default kernel images. This option might be interesting for you if you want a Debian system which doesn’t need to provide regular boot, e.g. a system which provides ISOs for booting via GRUB using grml-rescueboot.

--non-free
    Enable the non-free repository in COMPONENTS. For bookworm and newer Debian releases also the non-free-firmware repository gets enabled. By default only the main repository is enabled.

--nopackages
    Skip installation of packages defined in /etc/debootstrap/packages.

--nopassword
    Do not prompt for the root password. Note: Use the --password option if you want to set the root password during an automatic installation but don’t want to use the interactive dialog.

-p, --mntpoint /mntpoint
    Specify mount point that should be used for mounting the target system. Corresponding with configuration variable MNTPOINT. Note: this option has no effect if option -t is given and represents a directory.

--packages file
    Use specified file as list for packages that should be installed instead of the default package list file <confdir>/packages.

--password password
    Use specified password as password for user root. Use with caution, as your command line might be visible in the process list and the shell history. It’s meant for automatic installation only.

--post-scripts directory
    Execute scripts from specified directory after executing the chroot script. This allows customisation of the system after the chroot has been set up. The environment variable $MNTPOINT is available inside the scripts for direct access of the chroot. Default directory: /etc/debootstrap/post-scripts/

--pre-scripts directory
    Execute scripts from specified directory before executing the chroot script. This allows customisation of the system before the chroot has been set up. The environment variable $MNTPOINT is available inside the scripts for direct access of the chroot. Default directory: /etc/debootstrap/pre-scripts/

-r, --release releasename
    Specify release of new Debian system. Supported releases names: bookworm, trixie, forky and sid. Corresponding with configuration variable RELEASE. Default release: trixie

--remove-configs
    Delete grml-debootstrap configuration files (/etc/debootstrap/*) from installed system. Useful for reproducible builds or if you don’t want to leak information.

--rpi
    Set up a Raspberry Pi installation on an existing block device, which will be partitioned. This allows deployment of a physical Raspberry Pi system. The option needs to be combined with the --target option. This option automatically enables the --defaultinterfaces option. Usage example: --rpi --target /dev/mmcblk0

--rpifile
    Set up a Raspberry Pi installation using a regular file instead of installing to a partition/block device. This allows creation of a Raspberry Pi image. The option needs to be combined with the --target option (qemu-img create -f raw ... is executed on the specified target). This option automatically enables the --defaultinterfaces option. Usage example: --rpifile --target /mnt/sda1/rpi.img

--rpifirm device
    Partition where Raspberry Pi firmware should be installed to. If the specified device doesn’t use a FAT filesystem yet grml-debootstrap automatically creates the filesystem. If a FAT filesystem is already present the filesystem creation is skipped. Please ensure that it’s a valid FAT32 filesystem. This option is NOT supported for Raspberry Pi image file deployments.

--sshcopyauth
    Use locally available $HOME/.ssh/authorized_keys to authorise root login on the target system. This installs $HOME/.ssh/authorized_keys as /root/.ssh/authorized_keys on the target system. If a different file than $HOME/.ssh/authorized_keys should be used, the environment variable AUTHORIZED_KEYS_SOURCE can be used.

--sshcopyid
    Use locally available public keys to authorise root login on the target system. Similar to ssh-copy-id(1) (without the -i option) it checks if ssh-add -L provides any output, and if so those keys are appended to /root/.ssh/authorized_keys (creating the file and directory (with mode 0700)).

-t, --target target
    Target partition (/dev/...) or directory (anything else without /dev at the beginning).

-v, --verbose
    Increase verbosity.

--vm
    Set up a Virtual Machine on an existing block device, which will be partitioned. This allows deployment of a Virtual Machine. The options needs to be combined with the --target option. This option automatically enables the --defaultinterfaces option. Usage example: --vm --target /dev/mapper/your-vm-disk

--vmfile
    Set up a Virtual Machine using a regular file instead of installing to a partition/block device or directory. This allows deployment of a Virtual Machine. The options needs to be combined with the --target option (qemu-img create -f raw ... is executed on the specified target). This option automatically enables the --defaultinterfaces option. Usage example: --vmfile --target /mnt/sda1/qemu.img

--vmsize size
    Deprecated alias for --imagesize.

--vmefi
    Create an EFI boot partition for the VM.

-V, --version
    Show version of program and exit.

    Warning

    the command line parsing of grml-debootstrap usually does not validate the provided arguments for the command line options. Please be careful and check docs and /etc/debootstrap/config for further information.

NETWORKING

By default (that is, if none of the options --nointerfaces, --defaultinterfaces, --vmfile or --vm are given) /etc/network/interfaces will be copied from the host to the target system.

USAGE EXAMPLES

    grml-debootstrap --target /dev/sda1 --grub /dev/sda

Install default Debian release (trixie) on /dev/sda1 and install bootmanager GRUB in MBR (master boot record) of /dev/sda.

    grml-debootstrap --release bookworm --target /dev/sda1 --grub /dev/sda --hostname debian01 --password changeme

Install Debian release bookworm on /dev/sda1 and install bootmanager GRUB in MBR (master boot record) of /dev/sda. Set hostname to debian01 and password for user root to changeme.

    grml-debootstrap --target /dev/sda6 --grub /dev/sda --release sid

Install Debian unstable/sid on /dev/sda6 and install bootmanager GRUB in MBR (master boot record) of /dev/sda.

    grml-debootstrap --target /dev/sda1 --grub /dev/sda

Install default Debian release (trixie) on /dev/sda1 and install bootmanager GRUB in MBR (master boot record) of /dev/sda. Use mmdebstrap instead of default debootstrap tool for bootstrapping.

    grml-debootstrap --target /dev/mapper/vg0-rootfs --grub /dev/sda

Install default Debian release (trixie) on LVM device /dev/mapper/vg0-rootfs and install bootmanager GRUB in MBR (master boot record) of /dev/sda.

    grml-debootstrap --efi /dev/sda1 --target /dev/sda2 --grub /dev/sda

Install default Debian release (trixie) on /dev/sda2 and install bootmanager GRUB in MBR (master boot record) of /dev/sda. Use /dev/sda1 as EFI partition (requires EFI support in booted system).

    mount /dev/sda1 /data/chroot
    grml-debootstrap --target /data/chroot

Install default Debian release (trixie) in directory /data/chroot (without any bootloader).

    grml-debootstrap --target /dev/sda3 --grub /dev/sda  --mirror ftp://ftp.tugraz.at/mirror/debian

Install default Debian release (trixie) on /dev/sda3 and install bootmanager GRUB in MBR (master boot record) of /dev/sda. Use specified mirror instead of the default (http://deb.debian.org/debian) one.

    mount /dev/sda1 /mnt/sda1
    grml-debootstrap --vmfile --imagesize 3G --target /mnt/sda1/qemu.img

Install default debian release (trixie) in a Virtual Machine file with 3GB disk size (including GRUB as bootmanager in MBR of the virtual disk file).

FILES

    /etc/debootstrap/config

Main configuration file. Adjust it according to your needs if you want to execute grml-debootstrap in the non-interactive mode without any special command line arguments.

    /etc/debootstrap/chroot-script

The script executed within the new Debian system as soon as the main system has been installed via [c]debootstrap.

    /etc/debootstrap/locale.gen

Defines the default locales used for generating locales via locale-gen.

    /etc/debootstrap/packages

Defines the software packages which should be installed in the new Debian system by default.

    /etc/debootstrap/extrapackages/

Debian Packages dropped in this directory will be installed into the new Debian system by default (Control variable: EXTRAPACKAGES)

CUSTOMIZATION

You can control execution of grml-debootstrap via adjusting /etc/debootstrap/config for some main stuff or via setting some selected variables via command line. The packages which should be installed in the new Debian system can be defined via the file /etc/debootstrap/packages. If you want to put existing files to the new Debian system you can place them into the (by default non-existing) directories boot, etc, share, usr and var in /etc/debootstrap/. Every existing directory will be copied to the new Debian system then. If you want to install additional packages that are not available via the Grml or Debian mirror drop them into /etc/debootstrap/extrapackages and make sure that EXTRAPACKAGES is set to "yes".

SUPPORTED RELEASES

Table 1. Current status
Release | Status
bookworm | works
trixie | works
forky | works[1]
sid | works[1]

    unstable and testing releases

    [1] Please notice that Debian/testing (currently: forky) and Debian/unstable (sid) might not be always installable due to their nature. What might work instead is deploying a stable release and upgrade it after installation finished.

BUGS

Please report bugs towards https://github.com/grml/grml-debootstrap/issues

SEE ALSO

debootstrap(8), mmdebstrap(1).

AUTHOR

Michael Prokop <mika@grml.org[2]>

NOTES

1.  https://grml.org/grml-debootstrap/images/screenshot.png

2.  mika@grml.org
    mailto:mika@grml.org